{$A+,B-,E-,F+,I-,L-,O-,N-,P+,Q-,R-,S-,T-,V-,X+}

{ Copyright (C) 1995-96 By The GodFather }

UNIT GList_o;

INTERFACE

USES GUtils;

CONST
  lBackAttr   = $01;
  lTopicAttr  = $02;
  lsTopicAttr = $03;
  lBarAttr    = $04;
  lsBarAttr   = $05;

TYPE
  PList = ^TList;
  TList = RECORD
    XPos,Y,
    YPos,
    Lines,
    MaxLines,
    BarSize   : Byte;
    Position,
    MaxTopics : Integer;
    CanSelect,
    EndOfList : Boolean;
    ListPallete: ARRAY[1..5] OF Byte;
    GetString : FUNCTION(Position:Integer):STRING;
    GetSelect : FUNCTION(Position:Integer):Boolean;
    SetSelect : PROCEDURE(Positon:Integer; Flag:Boolean);
    CheckKey  : PROCEDURE(Position:Integer; VAR Key:Word);
    MiscProc  : PROCEDURE(Position:Integer);
    EmptyList : PROCEDURE;
  END;

PROCEDURE InitList(VAR List: PList);
PROCEDURE ShowList(VAR List: PList);
PROCEDURE DoneList(VAR List: PList);
PROCEDURE ReDrawList(VAR List: PList);
FUNCTION NoGetString(Position:Integer): STRING; FAR;
FUNCTION NoGetSelect(Position:Integer): Boolean; FAR;
PROCEDURE NoSetSelect(Position:Integer; Flag:Boolean); FAR;
PROCEDURE NoCheckKey(Position:Integer; VAR Key:Word); FAR;
PROCEDURE NoMiscProc(Position:Integer);

IMPLEMENTATION

{$F+}
FUNCTION NoGetString(Position:Integer): STRING;
VAR TempStr: STRING[2];
BEGIN
  Str(Position,TempStr);
  IF Length(TempStr) = 1 THEN TempStr := ' '+TempStr;
  NoGetString := 'Undefined '+TempStr;
END;

FUNCTION NoGetSelect(Position:Integer): Boolean;
BEGIN
  NoGetSelect := False;
END;

PROCEDURE NoSetSelect(Position:Integer; Flag:Boolean);
BEGIN
END;

PROCEDURE NoCheckKey(Position:Integer; VAR Key:Word);
BEGIN
END;

PROCEDURE NoMiscProc(Position:Integer);
BEGIN
END;

PROCEDURE NoEmptyList;
BEGIN
END;
{$F-}

PROCEDURE Print(VAR List: PList; ThisPosition:Integer; tempY:Byte; MenuBar: Boolean);
VAR S: STRING; A,I: Byte;
BEGIN
  WITH List^ DO
  BEGIN
    IF MenuBar THEN A := lBarAttr ELSE A := lTopicAttr;
    IF GetSelect(ThisPosition) THEN Inc(A);
    S := GetString(ThisPosition);
    IF Length(S) > BarSize THEN S[0] := Chr(BarSize);
    IF Length(S) < BarSize THEN
      FOR I:=Length(S) TO BarSize-1 DO S := S+' ';
    FastWrite(XPos, Pred(YPos)+tempY, ListPallete[A], S);
  END;
END;

PROCEDURE ReDrawList(VAR List: PList);
VAR FromPosition: Word; Index,TempY: Integer; Dummy: Boolean;
BEGIN
  TempY := 1;
  WITH List^ DO
  BEGIN
{   MaxLines := Lines;}
    IF MaxTopics = 0 THEN
    BEGIN
       FOR Index := YPos TO YPos+(MaxLines-1) DO
         FastWrite(XPos,Index,ListPallete[lBackAttr],Replicate(BarSize,' '));
       EmptyList;
       Exit;
    END;
    IF Position < MaxLines
      THEN FromPosition := 1
      ELSE FromPosition := Position-(Y-1);
    IF (MaxTopics<=MaxLines) THEN Lines := MaxTopics;
    IF (MaxTopics<=MaxLines) AND (Lines<=Y) THEN Y := Lines;
    IF FromPosition < 1 THEN FromPosition := 1;
    IF FromPosition+(Lines-1) > MaxTopics THEN FromPosition := MaxTopics-(Lines-1);
    IF Position < 1 THEN Position := 1;
    IF Position > MaxTopics THEN Position := MaxTopics;
    IF Position-Pred(Y) + Pred(Lines) > MaxTopics THEN Y := Lines-(MaxTopics-Position);
    IF Position < 1 + (Lines-1) THEN Y := Position;
    FOR Index := FromPosition TO FromPosition+(Lines-1) DO
    BEGIN
      IF TempY = Y THEN Dummy := True ELSE Dummy := False;
      Print(List,Index,tempY,Dummy);
      Inc(TempY);
      IF Index = MaxTopics THEN Break;
    END;
    IF Lines <> MaxLines THEN
    FOR Index := Lines TO MaxLines - 1 DO FastWrite(XPos,Index+YPos,ListPallete[lBackAttr],Replicate(BarSize,' '));
  END;
END;

PROCEDURE ShowList(VAR List: PList);

  PROCEDURE DisplayTopics(FromPosition: Word);
  VAR Index,TempY: Integer; Dummy: Boolean;
  BEGIN
    TempY := 1;
    WITH List^ DO
    BEGIN
      IF MaxTopics = 0 THEN
      BEGIN
         FOR Index := YPos TO YPos+(MaxLines-1) DO
           FastWrite(XPos,Index,ListPallete[lBackAttr],Replicate(BarSize,' '));
         EmptyList;
         Exit;
      END;
      IF FromPosition < 1 THEN FromPosition := 1;

      IF FromPosition+(Lines-1) > MaxTopics THEN FromPosition := MaxTopics-(Lines-1);
      FOR Index := FromPosition TO FromPosition+(Lines-1) DO
      BEGIN
        IF TempY = Y THEN Dummy := True ELSE Dummy := False;
        Print(List,Index,tempY,Dummy);
        Inc(TempY);
      END;
    END;
  END;

VAR Key: Word;

BEGIN
  WITH List^ DO
  BEGIN
    EndOfList := False;
    MaxLines := Lines;
    IF Position <= Lines
      THEN Y := Position
      ELSE Y := 1;
    IF Pred(YPos)+Lines   > MaxY THEN Lines   := MaxY-Pred(YPos);
    IF Pred(XPos)+BarSize > MaxX THEN BarSize := MaxX-Pred(XPos);
    IF Lines >= MaxTopics        THEN Lines   := MaxTopics;
    ReDrawList(List);
    REPEAT
      MiscProc(Position);
      Key := GetKey;
      CheckKey(Position,Key);
      IF MaxTopics = 0 THEN Key := 0;
      IF (Key = KbSpace) AND (CanSelect)
         THEN BEGIN
                Key := kbDown;
                SetSelect(Position,NOT GetSelect(Position));
                IF Position = MaxTopics THEN Print(List,Position,Y,True);
              END;
      IF (Position=1) AND ((Key=kbUp) OR (Key=kbPgUp) OR (Key=kbHome)) THEN Key := 0;
      IF (Position=MaxTopics) AND ((Key=kbDown) OR (Key=kbPgDn) OR (Key=kbEnd)) THEN Key := 0;
      CASE Key OF
          kbUp: BEGIN
                  IF Y <> 1 THEN Print(List,Position,Y,False);
                  Dec(Position);
                  IF Y <> 1
                    THEN Dec(Y)
                    ELSE DisplayTopics(Position);
                  Print(List,Position,Y,True);
                END;
        kbDown: BEGIN
                  IF Y <> Lines THEN Print(List,Position,Y,False);
                  Inc(Position);
                  IF Y <> Lines
                    THEN BEGIN Inc(Y); Print(List,Position,Y,True); END
                    ELSE DisplayTopics( Position-Pred(Lines) );
                END;
        kbPgUp: BEGIN
                  Y := 1;
                  Dec(Position,Lines-1);
                  IF Position < 1 THEN Position := 1;
                  DisplayTopics( Position );
                END;
        kbPgDn: BEGIN
                  Y := Lines;
                  Inc(Position,Lines-1);
                  IF Position > MaxTopics THEN Position := MaxTopics;
                  DisplayTopics( Position-Pred(Lines) );
                END;
        kbHome,
    kbCtrlPgUp: BEGIN
                  Y        := 1;
                  Position := 1;
                  DisplayTopics(1);
                END;
         kbEnd,
    kbCtrlPgDn: BEGIN
                  Y        := Lines;
                  Position := MaxTopics;
                  DisplayTopics( Position );
                END;
        kbEsc: EndOfList:= True;
      END;
    UNTIL EndOfList;
  END;
END;

PROCEDURE InitList(VAR List: PList);
BEGIN
  GetMem(List, SizeOf(List^));
  WITH List^ DO
  BEGIN
    XPos      := 1;  YPos    := 1;
    Lines     := 10; BarSize := 12;
    Position  := 1;  MaxTopics:= 10;
    CanSelect := False;
    EndOfList := False;
    GetString := NoGetString;
    GetSelect := NoGetSelect;
    SetSelect := NoSetSelect;
    CheckKey  := NoCheckKey;
    MiscProc  := NoMiscProc;
    EmptyList := NoEmptyList;
    ListPallete[lBackAttr]  := $17;
    ListPallete[lTopicAttr] := $17;
    ListPallete[lsTopicAttr]:= $1F;
    ListPallete[lBarAttr]   := $30;
    ListPallete[lsBarAttr]  := $2F;
  END;
END;

PROCEDURE DoneList(VAR List: PList);
BEGIN
  FreeMem(List, SizeOf(List^));
END;

END.
